/**************************************************************************************************
 *     CVS $Id: mouse_event.h,v 1.12 2003/11/19 17:19:26 dvhart Exp $
 * DESCRIPTION: Mouse event for button clicks and mouse motion. 
 *     AUTHORS: Darren Hart, Marc Strmke
 *  START DATE: 2003/Mar/03
 *
 *   COPYRIGHT: 2003 by Darren Hart, Vernon Mauery, Marc Strmke, Dirk Hrner
 *     LICENSE: This software is licenced under the Libstk license available with the source as 
 *              license.txt or at http://www.libstk.org/index.php?page=docs/license
 *************************************************************************************************/

#ifndef STK_MOUSE_EVENT_H
#define STK_MOUSE_EVENT_H

#include <boost/shared_ptr.hpp>
#include <libstk/event.h>

namespace stk
{
    class mouse_event : public event
    {
    public:
        typedef boost::shared_ptr<mouse_event> ptr;
        typedef boost::weak_ptr<mouse_event> weak_ptr;
    private:

    protected:
        int x_, y_, button_;

    public:
        mouse_event(int x=-1, int y=-1, int button=-1, event_type type=mouse_up);
        virtual ~mouse_event();
        int x() { return x_; }
        void x(int val) { x_ = val; }
        int y() { return y_; }
        void y(int val) { y_ = val; }
        int button() { return button_; }

    }; //class mouse_event

} // namespace stk

#endif
